#include "Tunnel.h"

Tunnel::Tunnel(SDL_Surface *screen, Collisions *gestionnaireCollisons, Sounderer *mediaPlayer, SDL_Surface* apparence)
: Power(screen, gestionnaireCollisons, mediaPlayer, apparence)
{

}///Constructeur

Tunnel::~Tunnel()
{

}///Destructeur

void Tunnel::usePower(int orientation, int &x, int &y, int const &ID)
{
    //[0] Bruitage
    m_mediaPlayer->play("Tunnel");

    //[1] Orientation de la trajectoire du Tunnel
    int posX(x);
    int posY(y);

    int ajoutX(0);
    int ajoutY(0);
    convertDir(orientation, ajoutX, ajoutY);

    //[2] Ajoute une ligne
    for ( int i(0); i < 10; i++ )
    {
        m_gestionnaireCollisions->ajouter(posX + ajoutY, posY + ajoutX, ID);
        m_gestionnaireCollisions->ajouter(posX - ajoutY, posY - ajoutX, ID);
        //m_gestionnaireCollisions->enlever(posX, posY)

        posX += ajoutX;
        posY += ajoutY;
    }

    //[END]
    m_used = true;
}///usePower

void Tunnel::postMortemPower(int const &x, int const &y, int const &ID)
{
    //[0] Bruitage
    m_mediaPlayer->play("Tunnel");

    //[1] Explosion de blocs
    for (int i(-1); i<=1; i++)
        for (int j(-1); j<=1; j++)
            if (i != 0 || j != 0) m_gestionnaireCollisions->ajouter(x+i, y+j, ID);

    //[end]
    m_used = true;
}///postMortemPower




