#ifndef STARTER_H
#define STARTER_H

#include <vector>
#include <fstream>
#include "Liner.h"
#include "intToStr.h"

/** \brief Voici la classe du Starter : elle place les liners en dbuts de partie.
 * \last Cr
 * \next
 *
 *
 */

class Starter
{
/// > Fonctions
    public:
        Starter( int xSize, int ySize );
        ~Starter();

        void loadAreas();
        void spawnLiners( Liner** linerTab, int nbJoueurs );

/// > Attributs
    private:
        int m_xSize ;
        int m_ySize ;

        std::vector< int > m_xl ; // Tableaux  dimensionner
        std::vector< int > m_yl ;
        std::vector< int > m_dl ;
};

#endif // STARTER_H
