#include "Bouclier.h"

Bouclier::Bouclier(SDL_Surface *screen, Collisions *gestionnaireCollisons, Sounderer *mediaPlayer, SDL_Surface* apparence)
: Power(screen, gestionnaireCollisons, mediaPlayer, apparence)
{

}///Constructeur

Bouclier::~Bouclier()
{

}///Destructeur

void Bouclier::usePower(int orientation, int &x, int &y, int const &ID)
{
    //[0] Bruitage
    m_mediaPlayer->play("Bouclier");

    //[1] Orientation de la trajectoire du Bouclier
    int ajoutX(0);
    int ajoutY(0);
    convertDir(orientation, ajoutY, ajoutX);//Perpendicularit

    //[2] Protect instant
    for (int i(-1); i <= 1; i++)
        m_gestionnaireCollisions->ajouter(x+ajoutX*i, y+ajoutY*i, ID);

    //[END]
    m_used = true;
}///usePower

void Bouclier::postMortemPower(int const &x, int const &y, int const &ID)
{
    //[0] Bruitage
    m_mediaPlayer->play("Bouclier");

    //Dsintgration du mur
    m_gestionnaireCollisions->enlever(x, y);

    //[end]
    m_used = true;
}///postMortemPower




