#ifndef MISSILE_H_INCLUDED
#define MISSILE_H_INCLUDED

#include "../Power.h"

/** \brief Missile : hrite de Power
 * \last Relecture et premires corrections
 * \next
 *
 *
 */

class Missile : public Power
{
    public:

        Missile(SDL_Surface *screen, Collisions *gestionnaireCollisons, Sounderer *mediaPlayer, SDL_Surface* apparence);
        virtual ~Missile();

        virtual void usePower(int orientation, int &x, int &y, int const &ID);
        virtual void postMortemPower(int const &x, int const &y, int const &ID);
};

#endif // MISSILE_H_INCLUDED
